--- django/conf/locale/ru/LC_MESSAGES/django.po	2011-01-06 18:06:23.056666722 +0300
+++ django/conf/locale/ru/LC_MESSAGES/django.po	2011-01-06 18:05:06.396666722 +0300
@@ -3672,6 +3672,386 @@
 msgid "Enter a valid postal code in the format XXXXXX"
 msgstr "Введите почтовый индекс в формате XXXXXX."
 
+#: contrib/localflavor/ru/forms.py:35
+msgid "Enter a postal code in the format XXXXXX."
+msgstr "Введите почтовый индекс в формате XXXXXX."
+
+#: contrib/localflavor/ru/forms.py:47
+msgid "Enter a passport number in the format XXXX XXXXXX."
+msgstr "Введите номер паспорта в формате XXXX XXXXXX."
+
+#: contrib/localflavor/ru/forms.py:59
+msgid "Enter a passport number in the format XX XXXXXXX."
+msgstr "Введите номер паспорта в формате XX XXXXXXX."
+
+#: contrib/localflavor/ru/forms.py:67
+msgid "Enter phone number in (XXX) XXX-XXXX format"
+msgstr "Введите номер телефона в формате (XXX) XXX-XXXX."
+
+#: contrib/localflavor/ru/ru_regions.py:9
+msgid "Central Federal County"
+msgstr "Центральный Федеральный Округ"
+
+#: contrib/localflavor/ru/ru_regions.py:10
+msgid "South Federal County"
+msgstr "Южный Федеральный Округ"
+
+#: contrib/localflavor/ru/ru_regions.py:11
+msgid "North-West Federal County"
+msgstr "Северо-Западный Федеральный Округ"
+
+#: contrib/localflavor/ru/ru_regions.py:12
+msgid "Far-East Federal County"
+msgstr "Дальневосточный Федеральный Округ"
+
+#: contrib/localflavor/ru/ru_regions.py:13
+msgid "Siberian Federal County"
+msgstr "Сибирский Федеральный Округ"
+
+#: contrib/localflavor/ru/ru_regions.py:14
+msgid "Ural Federal County"
+msgstr "Уральский Федеральный Округ"
+
+#: contrib/localflavor/ru/ru_regions.py:15
+msgid "Privolzhsky Federal County"
+msgstr "Приволжский Федеральный Округ"
+
+#: contrib/localflavor/ru/ru_regions.py:16
+msgid "North-Caucasian Federal County"
+msgstr "Северо-Кавказский Федеральный Округ"
+
+#: contrib/localflavor/ru/ru_regions.py:20
+msgid "Moskva"
+msgstr "Москва"
+
+#: contrib/localflavor/ru/ru_regions.py:21
+msgid "Saint-Peterburg"
+msgstr "Санкт-Петербург"
+
+#: contrib/localflavor/ru/ru_regions.py:22
+msgid "Moskovskaya oblast'"
+msgstr "Московская область"
+
+#: contrib/localflavor/ru/ru_regions.py:23
+msgid "Adygeya, Respublika"
+msgstr "Республика Адыгея"
+
+#: contrib/localflavor/ru/ru_regions.py:24
+msgid "Bashkortostan, Respublika"
+msgstr "Республика Башкортостан"
+
+#: contrib/localflavor/ru/ru_regions.py:25
+msgid "Buryatia, Respublika"
+msgstr "Республика Бурятия"
+
+#: contrib/localflavor/ru/ru_regions.py:26
+msgid "Altay, Respublika"
+msgstr "Республика Алтай"
+
+#: contrib/localflavor/ru/ru_regions.py:27
+msgid "Dagestan, Respublika"
+msgstr "Республика Дагестан"
+
+#: contrib/localflavor/ru/ru_regions.py:28
+msgid "Ingushskaya Respublika"
+msgstr "Республика Ингушетия"
+
+#: contrib/localflavor/ru/ru_regions.py:29
+msgid "Kabardino-Balkarskaya Respublika"
+msgstr "Кабардино-Балкарская республика"
+
+#: contrib/localflavor/ru/ru_regions.py:30
+msgid "Kalmykia, Respublika"
+msgstr "Республика Калмыкия"
+
+#: contrib/localflavor/ru/ru_regions.py:31
+msgid "Karachaevo-Cherkesskaya Respublika"
+msgstr "Карачаево-Черкесская республика"
+
+#: contrib/localflavor/ru/ru_regions.py:32
+msgid "Karelia, Respublika"
+msgstr "Республика Карелия"
+
+#: contrib/localflavor/ru/ru_regions.py:33
+msgid "Komi, Respublika"
+msgstr "Республика Коми"
+
+#: contrib/localflavor/ru/ru_regions.py:34
+msgid "Mariy Ehl, Respublika"
+msgstr "Республика Марий Эл"
+
+#: contrib/localflavor/ru/ru_regions.py:35
+msgid "Mordovia, Respublika"
+msgstr "Республика Мордовия"
+
+#: contrib/localflavor/ru/ru_regions.py:36
+msgid "Sakha, Respublika (Yakutiya)"
+msgstr "Республика Саха (Якутия)"
+
+#: contrib/localflavor/ru/ru_regions.py:37
+msgid "Severnaya Osetia, Respublika (Alania)"
+msgstr "Республика Северная Осетия — Алания"
+
+#: contrib/localflavor/ru/ru_regions.py:38
+msgid "Tatarstan, Respublika"
+msgstr "Республика Татарстан"
+
+#: contrib/localflavor/ru/ru_regions.py:39
+msgid "Tyva, Respublika (Tuva)"
+msgstr "Республика Тыва"
+
+#: contrib/localflavor/ru/ru_regions.py:40
+msgid "Udmurtskaya Respublika"
+msgstr "Удмуртская республика"
+
+#: contrib/localflavor/ru/ru_regions.py:41
+msgid "Khakassiya, Respublika"
+msgstr "Республика Хакасия"
+
+#: contrib/localflavor/ru/ru_regions.py:42
+msgid "Chechenskaya Respublika"
+msgstr "Чеченская республика"
+
+#: contrib/localflavor/ru/ru_regions.py:43
+msgid "Chuvashskaya Respublika"
+msgstr "Чувашская республика"
+
+#: contrib/localflavor/ru/ru_regions.py:44
+msgid "Altayskiy Kray"
+msgstr "Алтайский край"
+
+#: contrib/localflavor/ru/ru_regions.py:45
+msgid "Zabaykalskiy Kray"
+msgstr "Забайкальский край"
+
+#: contrib/localflavor/ru/ru_regions.py:46
+msgid "Kamchatskiy Kray"
+msgstr "Камчатский край"
+
+#: contrib/localflavor/ru/ru_regions.py:47
+msgid "Krasnodarskiy Kray"
+msgstr "Краснодарский край"
+
+#: contrib/localflavor/ru/ru_regions.py:48
+msgid "Krasnoyarskiy Kray"
+msgstr "Красноярский край"
+
+#: contrib/localflavor/ru/ru_regions.py:49
+msgid "Permskiy Kray"
+msgstr "Пермский край"
+
+#: contrib/localflavor/ru/ru_regions.py:50
+msgid "Primorskiy Kray"
+msgstr "Приморский край"
+
+#: contrib/localflavor/ru/ru_regions.py:51
+msgid "Stavropol'siyy Kray"
+msgstr "Ставропольский край"
+
+#: contrib/localflavor/ru/ru_regions.py:52
+msgid "Khabarovskiy Kray"
+msgstr "Хабаровский край"
+
+#: contrib/localflavor/ru/ru_regions.py:53
+msgid "Amurskaya oblast'"
+msgstr "Амурская область"
+
+#: contrib/localflavor/ru/ru_regions.py:54
+msgid "Arkhangel'skaya oblast'"
+msgstr "Архангельская область"
+
+#: contrib/localflavor/ru/ru_regions.py:55
+msgid "Astrakhanskaya oblast'"
+msgstr "Астраханская область"
+
+#: contrib/localflavor/ru/ru_regions.py:56
+msgid "Belgorodskaya oblast'"
+msgstr "Белгородская область"
+
+#: contrib/localflavor/ru/ru_regions.py:57
+msgid "Bryanskaya oblast'"
+msgstr "Брянская область"
+
+#: contrib/localflavor/ru/ru_regions.py:58
+msgid "Vladimirskaya oblast'"
+msgstr "Владимирская область"
+
+#: contrib/localflavor/ru/ru_regions.py:59
+msgid "Volgogradskaya oblast'"
+msgstr "Волгоградская область"
+
+#: contrib/localflavor/ru/ru_regions.py:60
+msgid "Vologodskaya oblast'"
+msgstr "Вологодская область"
+
+#: contrib/localflavor/ru/ru_regions.py:61
+msgid "Voronezhskaya oblast'"
+msgstr "Воронежская область"
+
+#: contrib/localflavor/ru/ru_regions.py:62
+msgid "Ivanovskaya oblast'"
+msgstr "Ивановская область"
+
+#: contrib/localflavor/ru/ru_regions.py:63
+msgid "Irkutskaya oblast'"
+msgstr "Иркутская область"
+
+#: contrib/localflavor/ru/ru_regions.py:64
+msgid "Kaliningradskaya oblast'"
+msgstr "Калининградская область"
+
+#: contrib/localflavor/ru/ru_regions.py:65
+msgid "Kaluzhskaya oblast'"
+msgstr "Калужская область"
+
+#: contrib/localflavor/ru/ru_regions.py:66
+msgid "Kemerovskaya oblast'"
+msgstr "Кемеровская область"
+
+#: contrib/localflavor/ru/ru_regions.py:67
+msgid "Kirovskaya oblast'"
+msgstr "Кировская область"
+
+#: contrib/localflavor/ru/ru_regions.py:68
+msgid "Kostromskaya oblast'"
+msgstr "Костромская область"
+
+#: contrib/localflavor/ru/ru_regions.py:69
+msgid "Kurganskaya oblast'"
+msgstr "Курганская область"
+
+#: contrib/localflavor/ru/ru_regions.py:70
+msgid "Kurskaya oblast'"
+msgstr "Курская область"
+
+#: contrib/localflavor/ru/ru_regions.py:71
+msgid "Leningradskaya oblast'"
+msgstr "Ленинградская область"
+
+#: contrib/localflavor/ru/ru_regions.py:72
+msgid "Lipeckaya oblast'"
+msgstr "Липецкая область"
+
+#: contrib/localflavor/ru/ru_regions.py:73
+msgid "Magadanskaya oblast'"
+msgstr "Магаданская область"
+
+#: contrib/localflavor/ru/ru_regions.py:74
+msgid "Murmanskaya oblast'"
+msgstr "Мурманская область"
+
+#: contrib/localflavor/ru/ru_regions.py:75
+msgid "Nizhegorodskaja oblast'"
+msgstr "Нижегородская область"
+
+#: contrib/localflavor/ru/ru_regions.py:76
+msgid "Novgorodskaya oblast'"
+msgstr "Новгородская область"
+
+#: contrib/localflavor/ru/ru_regions.py:77
+msgid "Novosibirskaya oblast'"
+msgstr "Новосибирская область"
+
+#: contrib/localflavor/ru/ru_regions.py:78
+msgid "Omskaya oblast'"
+msgstr "Омская область"
+
+#: contrib/localflavor/ru/ru_regions.py:79
+msgid "Orenburgskaya oblast'"
+msgstr "Оренбургская область"
+
+#: contrib/localflavor/ru/ru_regions.py:80
+msgid "Orlovskaya oblast'"
+msgstr "Орловская область"
+
+#: contrib/localflavor/ru/ru_regions.py:81
+msgid "Penzenskaya oblast'"
+msgstr "Пензенская область"
+
+#: contrib/localflavor/ru/ru_regions.py:82
+msgid "Pskovskaya oblast'"
+msgstr "Псковская область"
+
+#: contrib/localflavor/ru/ru_regions.py:83
+msgid "Rostovskaya oblast'"
+msgstr "Ростовская область"
+
+#: contrib/localflavor/ru/ru_regions.py:84
+msgid "Rjazanskaya oblast'"
+msgstr "Рязанская область"
+
+#: contrib/localflavor/ru/ru_regions.py:85
+msgid "Samarskaya oblast'"
+msgstr "Самарская область"
+
+#: contrib/localflavor/ru/ru_regions.py:86
+msgid "Saratovskaya oblast'"
+msgstr "Саратовская область"
+
+#: contrib/localflavor/ru/ru_regions.py:87
+msgid "Sakhalinskaya oblast'"
+msgstr "Сахалинская область"
+
+#: contrib/localflavor/ru/ru_regions.py:88
+msgid "Sverdlovskaya oblast'"
+msgstr "Свердловская область"
+
+#: contrib/localflavor/ru/ru_regions.py:89
+msgid "Smolenskaya oblast'"
+msgstr "Смоленская область"
+
+#: contrib/localflavor/ru/ru_regions.py:90
+msgid "Tambovskaya oblast'"
+msgstr "Тамбовская область"
+
+#: contrib/localflavor/ru/ru_regions.py:91
+msgid "Tverskaya oblast'"
+msgstr "Тверская область"
+
+#: contrib/localflavor/ru/ru_regions.py:92
+msgid "Tomskaya oblast'"
+msgstr "Томская область"
+
+#: contrib/localflavor/ru/ru_regions.py:93
+msgid "Tul'skaya oblast'"
+msgstr "Тульская область"
+
+#: contrib/localflavor/ru/ru_regions.py:94
+msgid "Tyumenskaya oblast'"
+msgstr "Тюменская область"
+
+#: contrib/localflavor/ru/ru_regions.py:95
+msgid "Ul'ianovskaya oblast'"
+msgstr "Ульяновская область"
+
+#: contrib/localflavor/ru/ru_regions.py:96
+msgid "Chelyabinskaya oblast'"
+msgstr "Челябинская область"
+
+#: contrib/localflavor/ru/ru_regions.py:97
+msgid "Yaroslavskaya oblast'"
+msgstr "Ярославская область"
+
+#: contrib/localflavor/ru/ru_regions.py:98
+msgid "Evreyskaya avtonomnaja oblast'"
+msgstr "Еврейская автономная область"
+
+#: contrib/localflavor/ru/ru_regions.py:99
+msgid "Neneckiy autonomnyy okrug"
+msgstr "Ненецкий автономный округ"
+
+#: contrib/localflavor/ru/ru_regions.py:100
+msgid "Khanty-Mansiyskiy avtonomnyy okrug - Yugra"
+msgstr "Ханты-Мансийский автономный округ - Югра"
+
+#: contrib/localflavor/ru/ru_regions.py:101
+msgid "Chukotskiy avtonomnyy okrug"
+msgstr "Чукотский автономный округ"
+
+#: contrib/localflavor/ru/ru_regions.py:102
+msgid "Yamalo-Neneckiy avtonomnyy okrug"
+msgstr "Ямало-Ненецкий автономный округ"
+
 #: contrib/localflavor/se/forms.py:50
 msgid "Enter a valid Swedish organisation number."
 msgstr "Введите правильный шведский идентификационный номер организации."