diff -r fe89b6629482 django/contrib/gis/db/backends/mysql/compiler.py
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/django/contrib/gis/db/backends/mysql/compiler.py	Fri Jan 28 12:59:14 2011 -0600
@@ -0,0 +1,22 @@
+from django.contrib.gis.db.models.sql.compiler import GeoSQLCompiler as BaseGeoSQLCompiler
+from django.db.backends.mysql import compiler
+
+SQLCompiler = compiler.SQLCompiler
+
+class GeoSQLCompiler(BaseGeoSQLCompiler, SQLCompiler):
+    pass
+
+class SQLInsertCompiler(compiler.SQLInsertCompiler, GeoSQLCompiler):
+    pass
+
+class SQLDeleteCompiler(compiler.SQLDeleteCompiler, GeoSQLCompiler):
+    pass
+
+class SQLUpdateCompiler(compiler.SQLUpdateCompiler, GeoSQLCompiler):
+    pass
+
+class SQLAggregateCompiler(compiler.SQLAggregateCompiler, GeoSQLCompiler):
+    pass
+
+class SQLDateCompiler(compiler.SQLDateCompiler, GeoSQLCompiler):
+    pass
diff -r fe89b6629482 django/contrib/gis/db/backends/mysql/operations.py
--- a/django/contrib/gis/db/backends/mysql/operations.py	Thu Jan 27 14:48:37 2011 +0000
+++ b/django/contrib/gis/db/backends/mysql/operations.py	Fri Jan 28 12:59:14 2011 -0600
@@ -5,7 +5,7 @@
 
 class MySQLOperations(DatabaseOperations, BaseSpatialOperations):
 
-    compiler_module = 'django.contrib.gis.db.models.sql.compiler'
+    compiler_module = 'django.contrib.gis.db.backends.mysql.compiler'
     mysql = True
     name = 'mysql'
     select = 'AsText(%s)'
diff -r fe89b6629482 django/contrib/gis/db/models/sql/compiler.py
--- a/django/contrib/gis/db/models/sql/compiler.py	Thu Jan 27 14:48:37 2011 +0000
+++ b/django/contrib/gis/db/models/sql/compiler.py	Fri Jan 28 12:59:14 2011 -0600
@@ -190,7 +190,8 @@
                                self.query.extra_select_fields.get(a, None),
                                self.connection)
                   for v, a in izip(row[rn_offset:index_start], aliases)]
-        if self.connection.ops.oracle or getattr(self.query, 'geo_values', False):
+
+        if self.connection.ops.oracle or self.connection.ops.mysql or getattr(self.query, 'geo_values', False):
             # We resolve the rest of the columns if we're on Oracle or if
             # the `geo_values` attribute is defined.
             for value, field in map(None, row[index_start:], fields):
diff -r fe89b6629482 django/contrib/gis/db/models/sql/query.py
--- a/django/contrib/gis/db/models/sql/query.py	Thu Jan 27 14:48:37 2011 +0000
+++ b/django/contrib/gis/db/models/sql/query.py	Fri Jan 28 12:59:14 2011 -0600
@@ -56,8 +56,8 @@
         extra selection objects into Geometry and Distance objects.
         TODO: Make converted objects 'lazy' for less overhead.
         """
-        if connection.ops.oracle:
-            # Running through Oracle's first.
+        if connection.ops.oracle or connection.ops.mysql:
+            # On MySQL and Oracle, call their version of `convert_values` first.
             value = super(GeoQuery, self).convert_values(value, field or GeomField(), connection)
 
         if value is None:
diff -r fe89b6629482 django/contrib/gis/tests/geoapp/models.py
--- a/django/contrib/gis/tests/geoapp/models.py	Thu Jan 27 14:48:37 2011 +0000
+++ b/django/contrib/gis/tests/geoapp/models.py	Fri Jan 28 12:59:14 2011 -0600
@@ -33,6 +33,10 @@
     objects = models.GeoManager()
     def __unicode__(self): return self.name
 
+class Truth(models.Model):
+    val = models.BooleanField()
+    objects = models.GeoManager()
+
 if not spatialite:
     class Feature(models.Model):
         name = models.CharField(max_length=20)
diff -r fe89b6629482 django/contrib/gis/tests/geoapp/test_regress.py
--- a/django/contrib/gis/tests/geoapp/test_regress.py	Thu Jan 27 14:48:37 2011 +0000
+++ b/django/contrib/gis/tests/geoapp/test_regress.py	Fri Jan 28 12:59:14 2011 -0600
@@ -1,9 +1,9 @@
-import os, unittest
+from django.test import TestCase
 from django.contrib.gis.tests.utils import no_mysql, no_oracle, no_postgis, no_spatialite
 from django.contrib.gis.shortcuts import render_to_kmz
-from models import City
+from models import City, Truth
 
-class GeoRegressionTests(unittest.TestCase):
+class GeoRegressionTests(TestCase):
 
     def test01_update(self):
         "Testing GeoQuerySet.update(), see #10411."
@@ -35,3 +35,11 @@
         extent = City.objects.filter(name='Pueblo').extent()
         for ref_val, val in zip(ref_ext, extent):
             self.assertAlmostEqual(ref_val, val, 4)
+
+    def test04_boolean_conversion(self):
+        "Testing Boolean value conversion with the spatial backend, see #15169."
+        t1 = Truth.objects.create(val=True)
+        t2 = Truth.objects.create(val=False)
+
+        self.assertTrue(Truth.objects.get(pk=1).val is True)
+        self.assertTrue(Truth.objects.get(pk=2).val is False)
diff -r fe89b6629482 django/db/backends/mysql/base.py
--- a/django/db/backends/mysql/base.py	Thu Jan 27 14:48:37 2011 +0000
+++ b/django/db/backends/mysql/base.py	Fri Jan 28 12:59:14 2011 -0600
@@ -136,6 +136,12 @@
 class DatabaseOperations(BaseDatabaseOperations):
     compiler_module = "django.db.backends.mysql.compiler"
 
+    def convert_values(self, value, field):
+        if (field and field.get_internal_type() in ("BooleanField", "NullBooleanField") and
+            value in (0, 1)):
+            value = bool(value)
+        return value
+
     def date_extract_sql(self, lookup_type, field_name):
         # http://dev.mysql.com/doc/mysql/en/date-and-time-functions.html
         if lookup_type == 'week_day':
diff -r fe89b6629482 django/db/backends/mysql/compiler.py
--- a/django/db/backends/mysql/compiler.py	Thu Jan 27 14:48:37 2011 +0000
+++ b/django/db/backends/mysql/compiler.py	Fri Jan 28 12:59:14 2011 -0600
@@ -5,10 +5,7 @@
         values = []
         index_extra_select = len(self.query.extra_select.keys())
         for value, field in map(None, row[index_extra_select:], fields):
-            if (field and field.get_internal_type() in ("BooleanField", "NullBooleanField") and
-                value in (0, 1)):
-                value = bool(value)
-            values.append(value)
+            values.append(self.query.convert_values(value, field, connection=self.connection))
         return row[:index_extra_select] + tuple(values)
 
 class SQLInsertCompiler(compiler.SQLInsertCompiler, SQLCompiler):