diff -r 7d7560c39fbd django/contrib/gis/db/backends/mysql/compiler.py
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/django/contrib/gis/db/backends/mysql/compiler.py	Fri Mar 02 17:35:44 2012 -0300
@@ -0,0 +1,22 @@
+from django.contrib.gis.db.models.sql.compiler import GeoSQLCompiler as BaseGeoSQLCompiler
+from django.db.backends.mysql import compiler
+
+SQLCompiler = compiler.SQLCompiler
+
+class GeoSQLCompiler(BaseGeoSQLCompiler, SQLCompiler):
+    pass
+
+class SQLInsertCompiler(compiler.SQLInsertCompiler, GeoSQLCompiler):
+    pass
+
+class SQLDeleteCompiler(compiler.SQLDeleteCompiler, GeoSQLCompiler):
+    pass
+
+class SQLUpdateCompiler(compiler.SQLUpdateCompiler, GeoSQLCompiler):
+    pass
+
+class SQLAggregateCompiler(compiler.SQLAggregateCompiler, GeoSQLCompiler):
+    pass
+
+class SQLDateCompiler(compiler.SQLDateCompiler, GeoSQLCompiler):
+    pass
diff -r 7d7560c39fbd django/contrib/gis/db/backends/mysql/operations.py
--- a/django/contrib/gis/db/backends/mysql/operations.py	Fri Mar 02 16:06:11 2012 +0000
+++ b/django/contrib/gis/db/backends/mysql/operations.py	Fri Mar 02 17:35:44 2012 -0300
@@ -5,7 +5,7 @@
 
 class MySQLOperations(DatabaseOperations, BaseSpatialOperations):
 
-    compiler_module = 'django.contrib.gis.db.models.sql.compiler'
+    compiler_module = 'django.contrib.gis.db.backends.mysql.compiler'
     mysql = True
     name = 'mysql'
     select = 'AsText(%s)'
diff -r 7d7560c39fbd django/contrib/gis/db/models/sql/compiler.py
--- a/django/contrib/gis/db/models/sql/compiler.py	Fri Mar 02 16:06:11 2012 +0000
+++ b/django/contrib/gis/db/models/sql/compiler.py	Fri Mar 02 17:35:44 2012 -0300
@@ -190,6 +190,12 @@
             # the `geo_values` attribute is defined.
             for value, field in map(None, row[index_start:], fields):
                 values.append(self.query.convert_values(value, field, self.connection))
+        elif self.connection.ops.mysql or getattr(self.query, 'geo_values', False):
+            for value, field in map(None, row[index_start:], fields):
+                if (field and field.get_internal_type() in ("BooleanField", "NullBooleanField") and
+                    value in (0, 1)):
+                    value = bool(value)
+                values.append(value)
         else:
             values.extend(row[index_start:])
         return tuple(values)
diff -r 7d7560c39fbd django/contrib/gis/tests/geoapp/models.py
--- a/django/contrib/gis/tests/geoapp/models.py	Fri Mar 02 16:06:11 2012 +0000
+++ b/django/contrib/gis/tests/geoapp/models.py	Fri Mar 02 17:35:44 2012 -0300
@@ -34,6 +34,10 @@
     objects = models.GeoManager()
     def __unicode__(self): return self.name
 
+class Truth(models.Model):
+    val = models.BooleanField()
+    objects = models.GeoManager()
+
 if not spatialite:
     class Feature(models.Model):
         name = models.CharField(max_length=20)
diff -r 7d7560c39fbd django/contrib/gis/tests/geoapp/test_regress.py
--- a/django/contrib/gis/tests/geoapp/test_regress.py	Fri Mar 02 16:06:11 2012 +0000
+++ b/django/contrib/gis/tests/geoapp/test_regress.py	Fri Mar 02 17:35:44 2012 -0300
@@ -7,7 +7,7 @@
 from django.db.models import Count
 from django.test import TestCase
 
-from .models import City, PennsylvaniaCity, State
+from .models import City, PennsylvaniaCity, State, Truth
 
 
 class GeoRegressionTests(TestCase):
@@ -64,3 +64,17 @@
         "Regression for #16409 - make sure defer() and only() work with annotate()"
         self.assertIsInstance(list(City.objects.annotate(Count('point')).defer('name')), list)
         self.assertIsInstance(list(City.objects.annotate(Count('point')).only('name')), list)
+
+    def test07_boolean_conversion(self):
+        "Testing Boolean value conversion with the spatial backend, see #15169."
+        t1 = Truth.objects.create(val=True)
+        t2 = Truth.objects.create(val=False)
+
+        val1 = Truth.objects.get(pk=1).val
+        val2 = Truth.objects.get(pk=2).val
+        # verify types -- should't be 0/1
+        self.assertIsInstance(val1, bool)
+        self.assertIsInstance(val2, bool)
+        # verify values
+        self.assertEqual(val1, True)
+        self.assertEqual(val2, False)